POJ 3126 Prime Path (BFS)

来源:互联网 发布:爱棋艺国际象棋软件 编辑:程序博客网 时间:2024/04/29 23:39
L - Prime Path
Time Limit:1000MS     Memory Limit:65536KB     64bit IO Format:%lld & %llu
Submit Status Practice POJ 3126
Appoint description: 

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033 
1733 
3733 
3739 
3779 
8779 
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

31033 81791373 80171033 1033

Sample Output

670
题意:给定两个素数a b,求a变幻到b需要几步
                并且变幻时只有一个数字不同,并且变换后的数是素数

#include<stdio.h>#include<string.h>#include<queue>#include<algorithm>#define MAX 10000using namespace std;bool prime[MAX];  void init(){    //对素数打表      int i,j;      for(i=1000;i<=MAX;i++){          for(j=2;j<i;j++)          if(i%j==0){              prime[i]=false;              break;          }          if(j==i) prime[i]=true;      }  }  int bfs(int first,int last){int count[MAX],t[5],i,j,k,l,v,temp;bool vis[MAX];memset(count,0,sizeof(count));memset(vis,false,sizeof(vis));queue<int>q;q.push(first);vis[first]=true;while(!q.empty()){v=q.front();q.pop();t[0]=v/1000%10;t[1]=v/100%10;t[2]=v/10%10;t[3]=v%10;for(i=0;i<4;i++){temp=t[i];for(j=0;j<10;j++)if(j!=temp){t[i]=j;k=t[0]*1000+t[1]*100+t[2]*10+t[3];if(!vis[k]&&prime[k]){count[k]=count[v]+1;vis[k]=true;q.push(k);}if(k==last)return count[k];}t[i]=temp;}if(v==last)return count[v];}return -1;}int main(){int t,a,b;scanf("%d",&t);init();//这个不能放到while里面 while(t--){scanf("%d%d",&a,&b);int ans=bfs(a,b);if(ans==-1)printf("Impossible\n");elseprintf("%d\n",ans); } return 0; }


0 0
原创粉丝点击